/**********************************************************************
Copyright (c) 2012 Alexander Kerner. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
 ***********************************************************************/

package net.sf.kerner.utils;

import javax.swing.text.View;

import net.sf.kerner.utils.impl.KeyValue;

/**
 * A {@link View} to a {@link KeyValue}, which returns only the key from this {@link KeyValue}.
 * <p>
 * <b>Example:</b><br>
 * </p>
 * <p>
 * 
 * <pre>
 * TODO example
 * </pre>
 * 
 * </p>
 * 
 * @author <a href="mailto:alex.kerner.24@googlemail.com">Alexander Kerner</a>
 * @version 2012-04-25
 * @param <K>
 *            type of key
 */
public class ViewKeyValueKey<K> implements Transformer<KeyValue<K, ?>, K> {

    /**
	 * 
	 */
    public K transform(final KeyValue<K, ?> element) {
        return element.getKey();
    }

}
